From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-lang/julia/
Date: Sat, 25 Sep 2021 02:58:54 +0000 (UTC) [thread overview]
Message-ID: <1632538712.4d7d331f387dfcf804dc7d7915d57ec582af2312.sam@gentoo> (raw)
commit: 4d7d331f387dfcf804dc7d7915d57ec582af2312
Author: Alessandro Barbieri <lssndrbarbieri <AT> gmail <DOT> com>
AuthorDate: Wed Apr 21 00:40:14 2021 +0000
Commit: Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat Sep 25 02:58:32 2021 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=4d7d331f
dev-lang/julia: julia doesn't work if cjk is in utf8proc
Closes: https://bugs.gentoo.org/782919
Package-Manager: Portage-3.0.18, Repoman-3.0.3
Signed-off-by: Alessandro Barbieri <lssndrbarbieri <AT> gmail.com>
Closes: https://github.com/gentoo/gentoo/pull/20479
Signed-off-by: Sam James <sam <AT> gentoo.org>
dev-lang/julia/julia-1.6.0-r1.ebuild | 177 +++++++++++++++++++++++++++++++++++
1 file changed, 177 insertions(+)
diff --git a/dev-lang/julia/julia-1.6.0-r1.ebuild b/dev-lang/julia/julia-1.6.0-r1.ebuild
new file mode 100644
index 00000000000..15b9d0a0324
--- /dev/null
+++ b/dev-lang/julia/julia-1.6.0-r1.ebuild
@@ -0,0 +1,177 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit llvm pax-utils toolchain-funcs
+
+# correct versions for stdlibs are in deps/checksums
+# for everything else, run with network-sandbox and wait for the crash
+
+MY_LIBUV_V="fb3e3364c33ae48c827f6b103e05c3f0e78b79a9"
+MY_LIBWHICH_V="81e9723c0273d78493dc8c8ed570f68d9ce7e89e"
+MY_LLVM_V="11.0.1"
+
+DESCRIPTION="High-performance programming language for technical computing"
+HOMEPAGE="https://julialang.org/"
+
+SRC_URI="
+ https://github.com/JuliaLang/julia/releases/download/v${PV}/${P}.tar.gz
+ https://api.github.com/repos/JuliaLang/libuv/tarball/${MY_LIBUV_V} -> ${PN}-libuv-${MY_LIBUV_V}.tar.gz
+ https://api.github.com/repos/vtjnash/libwhich/tarball/${MY_LIBWHICH_V} -> ${PN}-libwhich-${MY_LIBWHICH_V}.tar.gz
+ !system-llvm? ( https://github.com/llvm/llvm-project/releases/download/llvmorg-${MY_LLVM_V}/llvm-${MY_LLVM_V}.src.tar.xz )
+"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="+system-llvm"
+
+RDEPEND="
+ system-llvm? ( sys-devel/llvm:11=[llvm_targets_NVPTX(-)] )
+"
+LLVM_MAX_SLOT=11
+
+RDEPEND+="
+ app-arch/p7zip
+ dev-libs/gmp:0=
+ dev-libs/libgit2:0
+ >=dev-libs/libpcre2-10.23:0=[jit,unicode]
+ dev-libs/mpfr:0=
+ dev-libs/libutf8proc:0=[-cjk]
+ dev-util/patchelf
+ >=net-libs/mbedtls-2.2
+ net-misc/curl[http2,ssh]
+ sci-libs/amd:0=
+ sci-libs/arpack:0=
+ sci-libs/camd:0=
+ sci-libs/ccolamd:0=
+ sci-libs/cholmod:0=
+ sci-libs/colamd:0=
+ sci-libs/fftw:3.0=[threads]
+ sci-libs/openlibm:0=
+ sci-libs/spqr:0=
+ sci-libs/umfpack:0=
+ >=sci-mathematics/dsfmt-2.2.4
+ >=sys-libs/libunwind-1.1:0=
+ sys-libs/zlib:0=
+ >=virtual/blas-3.6
+ virtual/lapack"
+
+DEPEND="${RDEPEND}
+ dev-util/patchelf
+ virtual/pkgconfig
+ !system-llvm? ( dev-util/cmake )"
+
+PATCHES=(
+ "${FILESDIR}/${PN}"-1.1.0-fix_llvm_install.patch
+ "${FILESDIR}/${PN}"-1.4.0-no_symlink_llvm.patch
+ "${FILESDIR}/${PN}"-1.6.0-fix-system-csl.patch
+)
+
+pkg_setup() {
+ use system-llvm && llvm_pkg_setup
+}
+
+src_unpack() {
+ local tounpack=(${A})
+ # the main source tree, followed by deps
+ unpack "${tounpack[0]}"
+
+ mkdir -p "${S}/deps/srccache/"
+ for i in "${tounpack[@]:1}"; do
+ cp "${DISTDIR}/${i}" "${S}/deps/srccache/${i#julia-}" || die
+ done
+}
+
+src_prepare() {
+ default
+
+ # Sledgehammer:
+ # - prevent fetching of bundled stuff in compile and install phase
+ # - respect CFLAGS
+ # - respect EPREFIX and Gentoo specific paths
+
+ sed -i \
+ -e "\|SHIPFLAGS :=|c\\SHIPFLAGS := ${CFLAGS}" \
+ Make.inc || die
+
+ sed -i \
+ -e "s|ar -rcs|$(tc-getAR) -rcs|g" \
+ src/Makefile || die
+
+ # disable doc install starting git fetching
+ sed -i -e 's~install: $(build_depsbindir)/stringreplace $(BUILDROOT)/doc/_build/html/en/index.html~install: $(build_depsbindir)/stringreplace~' Makefile || die
+}
+
+src_configure() {
+ use system-llvm && ewarn "You have enabled system-llvm. This is unsupported by upstream and may not work."
+
+ # julia does not play well with the system versions of libuv
+ # USE_SYSTEM_LIBM=0 implies using external openlibm
+ cat <<-EOF > Make.user
+ LOCALBASE:="${EPREFIX}/usr"
+ override prefix:="${EPREFIX}/usr"
+ override libdir:="\$(prefix)/$(get_libdir)"
+ override CC:=$(tc-getCC)
+ override CXX:=$(tc-getCXX)
+ override AR:=$(tc-getAR)
+
+ BUNDLE_DEBUG_LIBS:=0
+ USE_BINARYBUILDER:=0
+ USE_SYSTEM_CSL:=1
+ USE_SYSTEM_LLVM:=$(usex system-llvm 1 0)
+ USE_SYSTEM_LIBUNWIND:=1
+ USE_SYSTEM_PCRE:=1
+ USE_SYSTEM_LIBM:=0
+ USE_SYSTEM_OPENLIBM:=1
+ USE_SYSTEM_DSFMT:=1
+ USE_SYSTEM_BLAS:=1
+ USE_SYSTEM_LAPACK:=1
+ USE_SYSTEM_GMP:=1
+ USE_SYSTEM_MPFR:=1
+ USE_SYSTEM_SUITESPARSE:=1
+ USE_SYSTEM_LIBUV:=0
+ USE_SYSTEM_UTF8PROC:=1
+ USE_SYSTEM_MBEDTLS:=1
+ USE_SYSTEM_LIBSSH2:=1
+ USE_SYSTEM_NGHTTP2:=1
+ USE_SYSTEM_CURL:=1
+ USE_SYSTEM_LIBGIT2:=1
+ USE_SYSTEM_PATCHELF:=1
+ USE_SYSTEM_ZLIB:=1
+ USE_SYSTEM_P7ZIP:=1
+ VERBOSE:=1
+ EOF
+}
+
+src_compile() {
+ # Julia accesses /proc/self/mem on Linux
+ addpredict /proc/self/mem
+
+ default
+ pax-mark m "$(file usr/bin/julia-* | awk -F : '/ELF/ {print $1}')"
+}
+
+src_install() {
+ emake install DESTDIR="${D}"
+
+ if ! use system-llvm ; then
+ local llvmslot=$(ver_cut 1 ${MY_LLVM_V})
+ cp "${S}/usr/lib/libLLVM-${llvmslot}jl.so" "${ED}/usr/$(get_libdir)/julia/" || die
+ fi
+
+ dodoc README.md
+
+ mv "${ED}"/usr/etc/julia "${ED}"/etc || die
+ rmdir "${ED}"/usr/etc || die
+ mv "${ED}"/usr/share/doc/julia/html "${ED}"/usr/share/doc/"${PF}" || die
+ rmdir "${ED}"/usr/share/doc/julia || die
+
+ # The appdata directory is deprecated.
+ mv "${ED}"/usr/share/{appdata,metainfo}/ || die
+}
+
+pkg_postinst() {
+ elog "To use Plots, you will need to install sci-visualization/gr."
+}
next reply other threads:[~2021-09-25 2:58 UTC|newest]
Thread overview: 79+ messages / expand[flat|nested] mbox.gz Atom feed top
2021-09-25 2:58 Sam James [this message]
-- strict thread matches above, loose matches on Subject: below --
2024-08-26 13:13 [gentoo-commits] repo/gentoo:master commit in: dev-lang/julia/ Eli Schwartz
2023-05-14 6:30 Matthias Maier
2023-05-02 0:39 Maciej Barć
2023-04-30 11:10 Maciej Barć
2023-02-13 16:53 Maciej Barć
2023-02-13 14:46 Maciej Barć
2023-01-01 22:45 Maciej Barć
2023-01-01 12:30 Maciej Barć
2022-12-13 6:28 Matthias Maier
2022-12-13 6:22 Matthias Maier
2022-12-13 5:30 Maciej Barć
2022-11-16 16:27 Maciej Barć
2022-10-08 23:21 Maciej Barć
2022-07-26 21:40 Maciej Barć
2022-06-06 5:17 Matthias Maier
2022-03-17 16:18 Maciej Barć
2022-01-04 16:21 Matthias Maier
2022-01-03 22:22 Matthias Maier
2022-01-03 21:37 Matthias Maier
2021-11-18 6:38 Matthias Maier
2021-04-08 2:31 Matthias Maier
2021-04-08 2:31 Matthias Maier
2021-04-08 2:31 Matthias Maier
2021-04-08 2:31 Matthias Maier
2021-04-08 2:31 Matthias Maier
2020-12-26 0:53 Matthias Maier
2020-12-25 23:28 Matthias Maier
2020-12-25 21:56 Matthias Maier
2020-12-25 21:56 Matthias Maier
2020-12-25 21:17 Matthias Maier
2020-12-04 5:53 Matthias Maier
2020-10-02 18:27 Matthias Maier
2020-10-02 17:42 Matthias Maier
2020-10-02 17:42 Matthias Maier
2020-07-01 16:38 Andreas K. Hüttel
2020-06-22 6:53 Andreas K. Hüttel
2020-06-21 19:49 Andreas K. Hüttel
2020-04-07 21:03 Matthias Maier
2020-04-04 19:32 Matthias Maier
2019-12-11 3:33 Matthias Maier
2019-12-11 3:33 Matthias Maier
2019-12-11 3:33 Matthias Maier
2019-09-22 2:18 Matthias Maier
2019-08-05 15:03 Matthias Maier
2019-05-25 17:42 Matthias Maier
2018-10-06 19:56 Matthias Maier
2018-09-04 1:20 Matthias Maier
2018-09-04 1:20 Matthias Maier
2018-08-31 3:23 Matthias Maier
2018-08-31 2:32 Matthias Maier
2018-08-31 2:32 Matthias Maier
2018-08-27 22:00 Matthias Maier
2018-07-01 4:49 Matthias Maier
2018-07-01 4:11 Matthias Maier
2018-06-30 22:55 Matthias Maier
2018-05-25 7:47 Fabian Groffen
2018-03-19 1:01 Matthias Maier
2018-03-19 1:01 Matthias Maier
2018-03-01 19:13 Matthias Maier
2017-11-28 11:12 Matthias Maier
2017-11-28 11:12 Matthias Maier
2017-11-28 11:12 Matthias Maier
2017-11-27 18:09 Matthias Maier
2017-11-27 18:09 Matthias Maier
2017-10-07 4:12 Matthias Maier
2017-09-25 7:35 Patrick Lauer
2017-09-25 6:44 Patrick Lauer
2017-09-16 5:27 Matthias Maier
2017-09-16 5:01 Matthias Maier
2017-07-27 0:41 Matthias Maier
2017-04-27 12:31 Patrick Lauer
2017-03-22 23:04 Matthias Maier
2016-09-25 5:49 Matthias Maier
2016-09-24 21:25 Matthias Maier
2016-07-05 19:04 Michał Górny
2016-04-13 5:53 Austin English
2016-01-22 17:14 Matthias Maier
2016-01-16 11:48 Matthias Maier
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1632538712.4d7d331f387dfcf804dc7d7915d57ec582af2312.sam@gentoo \
--to=sam@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox